#!/usr/bin/perl -w
# generate_dot.pl
# Emmanuel Jeannot, INRIA: emmanuel.jeannot@inria.fr
# Reads a extracted web file and generates dot file 

#Extract name, university, year of defence, country of defense, and dissertation title
#remove trailing spaces 
sub parse_input{
   $IN=$_[0];
   $student = <$IN>;
   $student =~ s/^\s*//;
   $student =~ s/\s*\n//;
   $univ= <$IN>;
   $univ =~ s/^\s*//;
   $univ =~ s/\s*\n//;
   $year= <$IN>;
   $year =~ s/^\s*//;
   $year =~ s/\s*\n//;
   $country =<$IN>;
   $country =~ s/^\s*//;
   $country =~ s/\s*\n//;
   $title = <$IN>;
   $title =~ s/^\s*//;
   $title =~ s/\s*\n//;
   return ($student,$univ,$year,$country,$title);
}

#Parse command line
print "digraph G {\n";

#For each imput
while (<STDIN>) {
   # read student characteristic and print them as a node in dot format
   if (/^(\d+):/) {
      $id=$1;
      ($student,$univ,$year,$country,$title)=parse_input(STDIN);
      $univ.=", " if($univ&&($year||$country));
      $year.=", " if($year&&$country);
      $country.="\\n" if($univ||$year||$country);
      $title.="\\n" if($title);
      printf "$id\[label=\"$student\\n$univ$year$country$title\"\,style=bold];\n";
   }elsif(/<-(\d+):(.*)/){
      # for each father plot an edge in dot format
      $adv_id=$1;
      $adv_name=$2;
      $adv_name =~ s/^\s*//;
      $adv_id =~ s/\s*\n//;
      if(($adv_id==38586)&&($id==17864)){ #special case for Euler -> Lagrange
	 print "$adv_id->$id [style=bold,style=dashed]\n";
      }else{
	 print "$adv_id->$id [style=bold]\n";
      }
   }else{
      die("cannot parse $_");
   }

}

print "}\n";
